// Java-Soundmodul by uja 26.10.07
// Aufruf: my_soundmodul.play_sound(nr);

package mahjongg;
import java.io.*;
import javax.sound.sampled.*;

public class soundmodul
{
  String pfad="/mahjongg/sounds/";
  String[] wavfile= { "klick.wav","error.wav","entfernen.wav","levelfertig.wav" };
  Clip[] saund=new Clip[wavfile.length]; // Sound-Effekt-Puffer

  soundmodul() // alle Sounds vorladen in Puffer saund:
  { for (int i=0; i<wavfile.length; i++)
    { try
      { AudioInputStream ais=AudioSystem.getAudioInputStream(this.getClass().getResourceAsStream(pfad+wavfile[i]));
        AudioFormat af = ais.getFormat();
        DataLine.Info info = new DataLine.Info(Clip.class,af,((int) ais.getFrameLength()*af.getFrameSize()) );
        saund[i] = (Clip)AudioSystem.getLine(info);
        saund[i].open(ais);
      }
      catch (Exception e) { System.out.println("Sound-Problem initializing: "+pfad+wavfile[i]); }
    }
  }

  void play_sound(int nr) { saund[nr].setFramePosition(0); saund[nr].start(); }
  void stop_sound(int nr) { saund[nr].stop(); }
  void close_soundall()   
  { for (int i=0; i<wavfile.length; i++) try { saund[i].close(); } catch (Exception e) { }
  }
} 