// ujas Java-MahJongg, abgeleitet von MahJongg-Big - V.16.12.07, vom Muell bereinigt
// --------------------------------------------------------------------------------------------

package mahjongg;

class spiel
{
  static final int maxsprites=144,xmax=36,ymax=24,zmax=8;
  static sprite[] stein=new sprite[maxsprites];
  static int rest=144;
  static String messi="";
  static boolean soundon=false;
  static int gewaehlt=-1;
  static int[] ulist   =new int[maxsprites+1];
  static int[] typliste=new int[maxsprites];
  static int[][] koo   =new int[maxsprites][3];
  static int[][][] f   =new int[xmax][ymax][zmax];

  main mama;
  soundmodul zaund=new soundmodul();
// -------------------------------------------------------------------------------------
// ab hier Methoden:
// -------------------------------------------------------------------------------------
  spiel(main parent) 
  { mama=parent;
    for (int i=0; i<maxsprites; i++) { typliste[i]=i%36; stein[i]=new sprite(i,typliste[i]); }
    set_pattern("drache.pat");
  }

  void neu(boolean flag)
  { int i;
    for (i=0; i<maxsprites; i++) stein[i].typ=typliste[i];
    if (flag) { mischen(); for (i=0; i<maxsprites; i++) typliste[i]=stein[i].typ; }
    rest=144;
    gewaehlt=-1;
    ulist[0]=0;
    mama.zugback.setEnabled(false);
    for (i=0; i<maxsprites; i++) stein[i].normal(); 
    messi=mama.langdef.get("LAYOUT")+": "+mama.get_pattname();
    messi=messi+"   "+mama.langdef.get("TILES")+": "+mama.get_tilename();
    messi=messi+"   "+mama.langdef.get("BACKGR")+": "+mama.get_backname();
  }

  void zeige_zuege()
  { int i,j,k;
    boolean zug=false;
    loesche_zugliste();
    if (gewaehlt>=0) stein[gewaehlt].normal();
    for (i=0; i<maxsprites; i++) if (stein[i].typ>=0) if (ist_frei(i))
    { k=stein[i].typ%36;
      for (j=0; j<maxsprites; j++) if (i!=j) if (stein[j].typ%36==k) if (ist_frei(j))
      { stein[i].hilite();
        stein[j].hilite();
        zug=true;
      }
    }
    if (zug) messi=mama.langdef.get("POSSMOVES")+": "; else mama.popup(mama.langdef.get("NOMOVES"));
  }

  void loesche_zugliste()
  { for (int i=0; i<maxsprites; i++) stein[i].normal();
    if (gewaehlt>=0) stein[gewaehlt].hilite();
  }

  void zugback()
  { int k;
    if (ulist[0]>0)
    { k=ulist[ulist[0]]; stein[k].typ=typliste[k]; ulist[0]--;
      k=ulist[ulist[0]]; stein[k].typ=typliste[k]; ulist[0]--;
    }
    rest=maxsprites-ulist[0];
    if (ulist[0]<1) mama.zugback.setEnabled(false);
  }

  void klick(int mx, int my)
  { int i,k=-1;
    messi="";
    mama.gamepanel.set_screen(0);
    loesche_zugliste();
    for (i=0; i<maxsprites; i++) if (stein[i].typ>=0) if (stein[i].in_rechteck(mx,my)) if (ist_frei(i))
    { if (k<0) k=i;
      else if (stein[k].iz<stein[i].iz) k=i;
    }
    if (k>=0)
    { if (gewaehlt<0) { stein[k].hilite(); gewaehlt=k; if (soundon) zaund.play_sound(0); }
      else if (gewaehlt==k) {  stein[gewaehlt].normal(); gewaehlt=-1; if (soundon) zaund.play_sound(1); }
      else if (stein[gewaehlt].typ%36==stein[k].typ%36)
      { ulist[0]++; ulist[ulist[0]]=gewaehlt;
        ulist[0]++; ulist[ulist[0]]=k;
        stein[gewaehlt].ausschalten();
        stein[k].ausschalten();
        gewaehlt=-1;
        rest=rest-2;
        if (soundon) zaund.play_sound(2);
        if (rest>0) mama.zugback.setEnabled(true); else if (soundon) zaund.play_sound(3);
      }
      else { stein[gewaehlt].normal(); gewaehlt=-1; if (soundon) zaund.play_sound(1); }
    }
  }

  void set_sound(boolean flag) { soundon=flag; }
  boolean ist_mitsound() { return soundon; }

  void set_pattern(String pattfile)
  { int i,j,k;
    for (k=0; k<zmax; k++) for (j=0; j<ymax; j++) for (i=0; i<xmax; i++) f[i][j][k]=0;
    koo=mama.load_pattern(pattfile);
    k=0;
    for (i=0; i<maxsprites; i++)
    { stein[i].set_koo(koo[i][0],koo[i][1],koo[i][2]);
      stein[i].typ=k;
      if (i%4==3) k++;
      f[koo[i][0]][koo[i][1]][koo[i][2]]=i+1;
    }
  }

  void mischen()
  { int i,j,k;
    for (i=0; i<maxsprites; i++)
    { k=(int)Math.floor(maxsprites*Math.random()%maxsprites);
      j=stein[i].typ; stein[i].typ=stein[k].typ; stein[k].typ=j;
    }
  }

  boolean ist_frei(int nr)
  { int i,ix,iy,iz;
    boolean rechts=true,links=true,frei=true;
    ix=stein[nr].ix; iy=stein[nr].iy; iz=stein[nr].iz;
    if (iz<zmax-1) // obere Ebene komplett frei:
    { if (f[ix][iy][iz+1]>0) if (stein[f[ix][iy][iz+1]-1].typ>=0) frei=false;
      if (ix>0) if (f[ix-1][iy][iz+1]>0) if (stein[f[ix-1][iy][iz+1]-1].typ>=0) frei=false;
      if (ix<xmax-1) if (f[ix+1][iy][iz+1]>0) if (stein[f[ix+1][iy][iz+1]-1].typ>=0) frei=false;
      if (frei) if (iy>0)
      { if (f[ix][iy-1][iz+1]>0) if (stein[f[ix][iy-1][iz+1]-1].typ>=0) frei=false;
        if (ix>0) if (f[ix-1][iy-1][iz+1]>0) if (stein[f[ix-1][iy-1][iz+1]-1].typ>=0) frei=false;
        if (ix<xmax-1) if (f[ix+1][iy-1][iz+1]>0) if (stein[f[ix+1][iy-1][iz+1]-1].typ>=0) frei=false;
      }
      if (frei) if (iy<ymax-1)
      { if (f[ix][iy+1][iz+1]>0) if (stein[f[ix][iy+1][iz+1]-1].typ>=0) frei=false;
        if (ix>0) if (f[ix-1][iy+1][iz+1]>0) if (stein[f[ix-1][iy+1][iz+1]-1].typ>=0) frei=false;
        if (ix<xmax-1) if (f[ix+1][iy+1][iz+1]>0) if (stein[f[ix+1][iy+1][iz+1]-1].typ>=0) frei=false;
      }
    }
    if (frei) // rechts oder links frei: 
    { if (ix>1)
      { if (f[ix-2][iy][iz]>0) if (stein[f[ix-2][iy][iz]-1].typ>=0) links=false;
        if (iy>0) if (f[ix-2][iy-1][iz]>0) if (stein[f[ix-2][iy-1][iz]-1].typ>=0) links=false;
        if (iy<ymax-1) if (f[ix-2][iy+1][iz]>0) if (stein[f[ix-2][iy+1][iz]-1].typ>=0) links=false;
      }
      if (ix<xmax-2)
      { if (f[ix+2][iy][iz]>0) if (stein[f[ix+2][iy][iz]-1].typ>=0) rechts=false;
        if (iy>0) if (f[ix+2][iy-1][iz]>0) if (stein[f[ix+2][iy-1][iz]-1].typ>=0) rechts=false;
        if (iy<ymax-1) if (f[ix+2][iy+1][iz]>0) if (stein[f[ix+2][iy+1][iz]-1].typ>=0) rechts=false;
      }
      frei=(rechts || links);
    }
    return frei;
  }


}
